//
// vc5smpDlg.cpp
// -------------
//  NetMan Mail/OCX32 Tv
//  (C) TechKnowledge, 1998 all rights reserved.
//  

#include "stdafx.h"
#include "vc5smp.h"
#include "vc5smpDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVc5smpDlg _CAO

CVc5smpDlg::CVc5smpDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVc5smpDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVc5smpDlg)
	m_Domain = _T("");
	m_Server = _T("");
	m_From = _T("");
	m_Subject = _T("");
	m_Text = _T("");
	m_To = _T("");
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CVc5smpDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVc5smpDlg)
	DDX_Control(pDX, IDC_ATTACHMENTS, m_Attachments);
	DDX_Text(pDX, IDC_DOMAIN, m_Domain);
	DDX_Text(pDX, IDC_SERVER, m_Server);
	DDX_Control(pDX, IDC_SMTP, m_Smtp);
	DDX_Text(pDX, IDC_FROM, m_From);
	DDX_Text(pDX, IDC_SUBJECT, m_Subject);
	DDX_Text(pDX, IDC_TEXT, m_Text);
	DDX_Text(pDX, IDC_TO, m_To);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CVc5smpDlg, CDialog)
	//{{AFX_MSG_MAP(CVc5smpDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CONNECT, OnConnect)
	ON_BN_CLICKED(IDC_END, OnEnd)
	ON_BN_CLICKED(IDC_SEND, OnSend)
	ON_BN_CLICKED(IDC_ATTACH, OnAttach)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVc5smpDlg bZ[W nh

BOOL CVc5smpDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	
	// TODO: ʂȏs͂̏ꏊɒǉĂB
	
	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CVc5smpDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CVc5smpDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CVc5smpDlg::OnConnect() 
{
  short rc;
  UpdateData();
  if( m_Server.IsEmpty() )
  {
    AfxMessageBox("T[o[͂Ă");
    return;
  }
  m_Smtp.SetRemoteHost(m_Server);
  m_Smtp.SetRemotePort(25);
  rc = m_Smtp.Connect();
  if( rc )
  {
    TRACE("connect fail %d\n",rc);
  }
  else
  {
    ::EnableWindow(GetDlgItem(IDC_CONNECT)->m_hWnd,FALSE);
    ::EnableWindow(GetDlgItem(IDC_ATTACH)->m_hWnd,TRUE);
    ::EnableWindow(GetDlgItem(IDC_SEND)->m_hWnd,TRUE);
    ::EnableWindow(GetDlgItem(IDC_END)->m_hWnd,TRUE);
  }
}

void CVc5smpDlg::OnEnd() 
{
  short rc;
  rc = m_Smtp.Quit();
  if(rc)
  {
    TRACE("quit fail %d\n",rc);
  }
  else
  {
    ::EnableWindow(GetDlgItem(IDC_CONNECT)->m_hWnd,TRUE);
    ::EnableWindow(GetDlgItem(IDC_ATTACH)->m_hWnd,FALSE);
    ::EnableWindow(GetDlgItem(IDC_SEND)->m_hWnd,FALSE);
    ::EnableWindow(GetDlgItem(IDC_END)->m_hWnd,FALSE);
  }
}

void CVc5smpDlg::OnSend() 
{
  short rc;
  UpdateData();

  m_Smtp.SetDomainAddress(m_Domain);
  m_Smtp.SetTo(m_To);
  m_Smtp.SetFrom(m_From);
  m_Smtp.SetSubject(m_Subject);
  m_Smtp.SetDocInType(0);
  m_Smtp.SetDocInput(m_Text);
  rc = m_Smtp.SendMessage();
	if(rc)
  {
    TRACE("send fail %d\n",rc);
  }
  else
  {
    AfxMessageBox("M");
  }
  ::SetWindowText(GetDlgItem(IDC_TEXT)->m_hWnd,NULL);
  m_Attachments.ResetContent();
}

void CVc5smpDlg::OnAttach() 
{
  CFileDialog dlg(TRUE);
	UpdateData();

  if( dlg.DoModal() == IDOK )
  {
    short rc;
    short sPartNumber;
    VARIANT ContentType;
    VARIANT ContentEncode;
    VariantInit(&ContentType);
    VariantInit(&ContentEncode);

    CString FileName = dlg.GetFileName();
    m_Smtp.SetDocInType(1);
    m_Smtp.SetDocInFileName(FileName);
    m_Smtp.SetContentTransferEncoding(0);    // base 64

    rc = m_Smtp.SendMultiMessage(&sPartNumber,&ContentType,&ContentEncode);
    if(rc)
    {
      TRACE("attach fail %d\n",rc);
      return;
    }
    // insert to list box
    m_Attachments.AddString(FileName);

    VariantClear(&ContentType);
    VariantClear(&ContentEncode);
  }
}
